Status: Closed Start date:  
Category: Text formatting Estimated time: 0.00 hour

Target version: 4.0.3   

Resolution: Fixed Affected version:  

Description

According to the Wiki formatting help, You can link to wiki pages of another project using the following syntax.

[[sandbox:some page]]

[[sandbox:]]

 However, it does not work if the name of the destination project includes "[" or "]" character.

For example, suppose that there is a project named "[Foo]Bar". If you want to link to wiki pages in the project, the syntax is 

"[[[Foo]Bar:PageName]]". However, it does not generate any link.

 

Related issues:

Related to Redmine - Defect #20397: project:someproject wiki syntax should li... New

Associated revisions

Revision 17906 - 2019-02-28 00:44 - Go MAEDA

Cannot make cross-project wiki link if the project name includes square brackets (#30256).

Patch by Yuichi HARADA.

Revision 17912 - 2019-03-03 02:46 - Go MAEDA

Merged r17906 from trunk to 4.0-stable (#30256).

History

#1 - 2018-12-21 00:41 - Go MAEDA

- Related to Defect #20397: project:someproject wiki syntax should link to project with identifier "someproject', not name. added

#2 - 2019-01-11 07:06 - Yuichi HARADA

- File 30256-make-wiki-link-includes-brackets.patch added

I reviewed the regular expression as follows.(Change from "greedy quantifier" to "lazy quantifier")

https://ruby-doc.org/core-2.6/doc/regexp_rdoc.html#label-Repetition

I attached a patch.
diff --git a/app/helpers/application_helper.rb b/app/helpers/application_helper.rb

index e250c20ee..8fa56ac55 100644

--- a/app/helpers/application_helper.rb

+++ b/app/helpers/application_helper.rb

@@ -787,7 +787,7 @@ module ApplicationHelper

   #   [[project:mypage]]

   #   [[project:mypage|mytext]]

   def parse_wiki_links(text, project, obj, attr, only_path, options)

-    text.gsub!(/(!)?(\[\[([^\]\n\|]+)(\|([^\]\n\|]+))?\]\])/) do |m|

+    text.gsub!(/(!)?(\[\[([^\n\|]+?)(\|([^\n\|]+?))?\]\])/) do |m|

       link_project = project

       esc, all, page, title = $1, $2, $3, $5

       if esc.nil?

#3 - 2019-02-02 07:23 - Go MAEDA

- Target version set to Candidate for next minor release

#4 - 2019-02-27 16:02 - Go MAEDA

- Target version changed from Candidate for next minor release to 4.0.3

LGTM. Setting the target version to 4.0.3.

#5 - 2019-02-28 00:44 - Go MAEDA

- Subject changed from Cannot make cross-project wiki link if the project name includes "[" or "]" to Cannot make cross-project wiki link if the project

name includes square brackets

- Status changed from New to Resolved

- Assignee set to Go MAEDA

- Resolution set to Fixed

Committed the patch. Thank you for your contribution.

#6 - 2019-03-03 02:46 - Go MAEDA

- Status changed from Resolved to Closed
